module     [% process_name asprefix=\_ %]pjfry_comb
! This module has been generated using a script.
! Please, refrain from modifying it directly!
use precision_golem, only: ki
use [% process_name asprefix=\_ %]precision_pjfry, only: ki_pjf
use array, only: packb, unpackb, countb, pminus, punion
use tens_rec, only: coeff_type_1, reconstruct1, coeff_type_2, reconstruct2, &
   & coeff_type_3, reconstruct3, coeff_type_4, reconstruct4, coeff_type_5, &
   & reconstruct5
implicit none
private
real(ki), dimension(0:3), parameter, private :: null_vec = &
 & (/0.0_ki,0.0_ki,0.0_ki,0.0_ki/)
interface evaluate
   module procedure evaluate_b
   module procedure evaluate_s
end interface
public :: evaluate
public :: contract2_1
public :: contract2_2,contract2_2s1
public :: contract3_1
public :: contract3_2,contract3_2s1
public :: contract3_3,contract3_3s1
public :: contract4_1
public :: contract4_2,contract4_2s1
public :: contract4_3,contract4_3s1
public :: contract4_4,contract4_4s1,contract4_4s2
public :: contract5_1
public :: contract5_2
public :: contract5_3
public :: contract5_4
public :: contract5_5
public :: contract_a_tensor_1
public :: contract_a_tensor_2,contract_b_tensor_2
public :: contract_a_tensor_3,contract_b_tensor_3
public :: contract_a_tensor_4,contract_b_tensor_4,contract_c_tensor_4
public :: contract_a_tensor_5,contract_b_tensor_5,contract_c_tensor_5
integer, parameter, public :: b_ref2 = 6
integer, parameter, public :: b_ref3 = 14
integer, parameter, public :: b_ref4 = 30
integer, parameter, public :: b_ref5 = 62
integer, public :: b_ref
contains
function     evaluate_s(numeval, momenta, set, ep, rank) result(amp)
   ! generated by: write_function_evaluate
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   interface
      function numeval(Q, mu2)
         use precision_golem, only: ki
         implicit none
         real(ki), dimension(0:3), intent(in) :: Q
         real(ki), intent(in) :: mu2
         complex(ki) :: numeval
      end function numeval
   end interface
   real(ki), dimension(:,:), intent(in) :: momenta
   integer, dimension(:), intent(in) :: set
   integer, intent(in) :: ep
   integer, intent(in), optional :: rank
   complex(ki_pjf) :: amp
   if (present(rank)) then
      amp = evaluate_b(numeval, momenta, packb(set), ep, rank)
   else
      amp = evaluate_b(numeval, momenta, packb(set), ep)
   end if
end function evaluate_s
function     evaluate_b(numeval, momenta, b_set, ep, rank) result(amp)
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   interface
      function numeval(Q, mu2)
         use precision_golem, only: ki
         implicit none
         real(ki), dimension(0:3), intent(in) :: Q
         real(ki), intent(in) :: mu2
         complex(ki) :: numeval
      end function numeval
   end interface
   real(ki), dimension(:,:), intent(in) :: momenta
   integer, intent(in) :: b_set
   integer, intent(in), optional :: rank
   integer, intent(in) :: ep
   complex(ki_pjf) :: amp
   integer :: N, r
   complex(ki) :: coeffs0
   type(coeff_type_1) :: coeffs1
   type(coeff_type_2) :: coeffs2, coeffs2x
   type(coeff_type_3) :: coeffs3
   type(coeff_type_4) :: coeffs4
   type(coeff_type_5) :: coeffs5
   N = size(momenta,1) - countb(b_set)
   if (present(rank)) then
      r = rank
   else
      r = N
   end if
   select case(N)
   case(1)
      select case(r)
      case(0)
         coeffs0 = numeval(null_vec, 0.0_ki)
         print*, "Tadpoles not implemented yet"
         stop
      case(1)
         call reconstruct1(numeval, coeffs1)
         print*, "Tadpoles not implemented yet"
         stop
      case default
         print*, "Not yet implemented: N, r = ", 1, r
         stop
      end select
   case(2)
      select case(r)
      case(0)
         coeffs0 = numeval(null_vec, 0.0_ki)
         amp = coeffs0 * pga20(b_set, ep)
      case(1)
         call reconstruct1(numeval, coeffs1)
         amp = contract2_1(coeffs1,momenta,b_set,ep)
      case(2)
         call reconstruct2(numeval, coeffs2, coeffs0)
         amp = contract2_2(coeffs2,momenta,b_set,ep)
         amp = amp + contract2_2s1(coeffs0,momenta,b_set,ep)
      case default
         print*, "Not yet implemented: N, r = ", 2, r
         stop
      end select
   case(3)
      select case(r)
      case(0)
         coeffs0 = numeval(null_vec, 0.0_ki)
         amp = coeffs0 * pga30(b_set, ep)
      case(1)
         call reconstruct1(numeval, coeffs1)
         amp = contract3_1(coeffs1,momenta,b_set,ep)
      case(2)
         call reconstruct2(numeval, coeffs2, coeffs0)
         amp = contract3_2(coeffs2,momenta,b_set,ep)
         amp = amp + contract3_2s1(coeffs0,momenta,b_set,ep)
      case(3)
         call reconstruct3(numeval, coeffs3, coeffs1)
         amp = contract3_3(coeffs3,momenta,b_set,ep)
         amp = amp + contract3_3s1(coeffs1,momenta,b_set,ep)
      case default
         print*, "Not yet implemented: N, r = ", 3, r
         stop
      end select
   case(4)
      select case(r)
      case(0)
         coeffs0 = numeval(null_vec, 0.0_ki)
         amp = coeffs0 * pga40(b_set, ep)
      case(1)
         call reconstruct1(numeval, coeffs1)
         amp = contract4_1(coeffs1,momenta,b_set,ep)
      case(2)
         call reconstruct2(numeval, coeffs2, coeffs0)
         amp = contract4_2(coeffs2,momenta,b_set,ep)
         amp = amp + contract4_2s1(coeffs0,momenta,b_set,ep)
      case(3)
         call reconstruct3(numeval, coeffs3, coeffs1)
         amp = contract4_3(coeffs3,momenta,b_set,ep)
         amp = amp + contract4_3s1(coeffs1,momenta,b_set,ep)
      case(4)
         call reconstruct4(numeval, coeffs4, coeffs2, coeffs2x)
         amp = contract4_4(coeffs4,momenta,b_set,ep)
         amp = amp + contract4_4s1(coeffs2,momenta,b_set,ep)
         amp = amp + contract4_4s2(coeffs2x,momenta,b_set,ep)
      case default
         print*, "Not yet implemented: N, r = ", 4, r
         stop
      end select
   case(5)
      select case(r)
      case(0)
         coeffs0 = numeval(null_vec, 0.0_ki)
         amp = coeffs0 * pga50(b_set, ep)
      case(1)
         call reconstruct1(numeval, coeffs1)
         amp = contract5_1(coeffs1,momenta,b_set,ep)
      case(2)
         call reconstruct2(numeval, coeffs2)
         amp = contract5_2(coeffs2,momenta,b_set,ep)
      case(3)
         call reconstruct3(numeval, coeffs3)
         amp = contract5_3(coeffs3,momenta,b_set,ep)
      case(4)
         call reconstruct4(numeval, coeffs4)
         amp = contract5_4(coeffs4,momenta,b_set,ep)
      case(5)
         call reconstruct5(numeval, coeffs5)
         amp = contract5_5(coeffs5,momenta,b_set,ep)
      case default
         print*, "Not yet implemented: N, r = ", 5, r
         stop
      end select
   case default
      print*, "Not yet implemented: N=", N
      stop
   end select
end function evaluate_b
function     contract2_1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_1), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   integer :: l1, l2
   integer, dimension(2) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 2)
   l1 = unpinched(1)
   l2 = unpinched(2)
   amp = coeffs%c0 * pga20(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga21(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga21(l2, b_set, ep)
end function contract2_1
function     contract2_2(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   integer :: l1, l2
   integer, dimension(2) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 2)
   l1 = unpinched(1)
   l2 = unpinched(2)
   amp = coeffs%c0 * pga20(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga21(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga21(l2, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga22(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga22(l1, l2, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga22(l2, l2, b_set, ep)
   amp = amp + contract_b_tensor_2(coeffs) * pgb22(b_set, ep)
end function contract2_2
function     contract2_2s1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   complex(ki), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   integer :: l1, l2
   integer, dimension(2) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 2)
   if (ep .ge. 2) then
      amp = (0.0_ki_pjf, 0.0_ki_pjf)
      return
   endif
   l1 = unpinched(1)
   l2 = unpinched(2)
   amp = coeffs * pgb22(b_set, ep+1)
   ! multiply by 2
   amp = 2.0_ki*amp
end function contract2_2s1
function     contract3_1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_1), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   integer :: l1, l2, l3
   integer, dimension(3) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 3)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   amp = coeffs%c0 * pga30(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga31(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga31(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga31(l3, b_set, ep)
end function contract3_1
function     contract3_2(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   integer :: l1, l2, l3
   integer, dimension(3) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 3)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   amp = coeffs%c0 * pga30(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga31(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga31(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga31(l3, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga32(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga32(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga32(l1, l3, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga32(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga32(l2, l3, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga32(l3, l3, b_set, ep)
   amp = amp + contract_b_tensor_2(coeffs) * pgb32(b_set, ep)
end function contract3_2
function     contract3_2s1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   complex(ki), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   integer :: l1, l2, l3
   integer, dimension(3) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 3)
   if (ep .ge. 2) then
      amp = (0.0_ki_pjf, 0.0_ki_pjf)
      return
   endif
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   amp = coeffs * pgb32(b_set, ep+1)
   ! multiply by 2
   amp = 2.0_ki*amp
end function contract3_2s1
function     contract3_3(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_3), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   real(ki), dimension(3,0:3) :: mom3
   integer :: l1, l2, l3
   integer, dimension(3) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 3)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   amp = coeffs%c0 * pga30(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga31(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga31(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga31(l3, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga32(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga32(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga32(l1, l3, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga32(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga32(l2, l3, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga32(l3, l3, b_set, ep)
   amp = amp + contract_b_tensor_3(coeffs) * pgb32(b_set, ep)
   mom3 = momenta((/l1,l1,l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga33(l1, l1, l1, b_set, ep)
   mom3 = momenta((/l1,l1,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga33(l1, l1, l2, b_set, ep)
   mom3 = momenta((/l1,l1,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga33(l1, l1, l3, b_set, ep)
   mom3 = momenta((/l1,l2,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga33(l1, l2, l2, b_set, ep)
   mom3 = momenta((/l1,l2,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga33(l1, l2, l3, b_set, ep)
   mom3 = momenta((/l1,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga33(l1, l3, l3, b_set, ep)
   mom3 = momenta((/l2,l2,l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga33(l2, l2, l2, b_set, ep)
   mom3 = momenta((/l2,l2,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga33(l2, l2, l3, b_set, ep)
   mom3 = momenta((/l2,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga33(l2, l3, l3, b_set, ep)
   mom3 = momenta((/l3,l3,l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga33(l3, l3, l3, b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb33(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb33(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb33(l3, b_set, ep)
end function contract3_3
function     contract3_3s1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_1), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   integer :: l1, l2, l3
   integer, dimension(3) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 3)
   if (ep .ge. 2) then
      amp = (0.0_ki_pjf, 0.0_ki_pjf)
      return
   endif
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   amp = coeffs%c0 * pgb32(b_set, ep+1)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pgb33(l1, b_set, ep+1)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pgb33(l2, b_set, ep+1)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pgb33(l3, b_set, ep+1)
   ! multiply by 2
   amp = 2.0_ki*amp
end function contract3_3s1
function     contract4_1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_1), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = coeffs%c0 * pga40(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga41(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga41(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga41(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga41(l4, b_set, ep)
end function contract4_1
function     contract4_2(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = coeffs%c0 * pga40(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga41(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga41(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga41(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga41(l4, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga42(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga42(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga42(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga42(l1, l4, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga42(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga42(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga42(l2, l4, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga42(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga42(l3, l4, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga42(l4, l4, b_set, ep)
   amp = amp + contract_b_tensor_2(coeffs) * pgb42(b_set, ep)
end function contract4_2
function     contract4_2s1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   complex(ki), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   if (ep .ge. 2) then
      amp = (0.0_ki_pjf, 0.0_ki_pjf)
      return
   endif
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = 0.0_ki
end function contract4_2s1
function     contract4_3(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_3), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   real(ki), dimension(3,0:3) :: mom3
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = coeffs%c0 * pga40(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga41(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga41(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga41(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga41(l4, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga42(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga42(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga42(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga42(l1, l4, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga42(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga42(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga42(l2, l4, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga42(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga42(l3, l4, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga42(l4, l4, b_set, ep)
   amp = amp + contract_b_tensor_3(coeffs) * pgb42(b_set, ep)
   mom3 = momenta((/l1,l1,l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga43(l1, l1, l1, b_set, ep)
   mom3 = momenta((/l1,l1,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l1, l2, b_set, ep)
   mom3 = momenta((/l1,l1,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l1, l3, b_set, ep)
   mom3 = momenta((/l1,l1,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l1, l4, b_set, ep)
   mom3 = momenta((/l1,l2,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l2, l2, b_set, ep)
   mom3 = momenta((/l1,l2,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l2, l3, b_set, ep)
   mom3 = momenta((/l1,l2,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l2, l4, b_set, ep)
   mom3 = momenta((/l1,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l3, l3, b_set, ep)
   mom3 = momenta((/l1,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l3, l4, b_set, ep)
   mom3 = momenta((/l1,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l1, l4, l4, b_set, ep)
   mom3 = momenta((/l2,l2,l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga43(l2, l2, l2, b_set, ep)
   mom3 = momenta((/l2,l2,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l2, l2, l3, b_set, ep)
   mom3 = momenta((/l2,l2,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l2, l2, l4, b_set, ep)
   mom3 = momenta((/l2,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l2, l3, l3, b_set, ep)
   mom3 = momenta((/l2,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l2, l3, l4, b_set, ep)
   mom3 = momenta((/l2,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l2, l4, l4, b_set, ep)
   mom3 = momenta((/l3,l3,l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga43(l3, l3, l3, b_set, ep)
   mom3 = momenta((/l3,l3,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l3, l3, l4, b_set, ep)
   mom3 = momenta((/l3,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga43(l3, l4, l4, b_set, ep)
   mom3 = momenta((/l4,l4,l4/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga43(l4, l4, l4, b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb43(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb43(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb43(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb43(l4, b_set, ep)
end function contract4_3
function     contract4_3s1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_1), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   if (ep .ge. 2) then
      amp = (0.0_ki_pjf, 0.0_ki_pjf)
      return
   endif
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = 0.0_ki
end function contract4_3s1
function     contract4_4(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_4), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   real(ki), dimension(3,0:3) :: mom3
   real(ki), dimension(4,0:3) :: mom4
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = coeffs%c0 * pga40(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga41(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga41(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga41(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga41(l4, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga42(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga42(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga42(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga42(l1, l4, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga42(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga42(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga42(l2, l4, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga42(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga42(l3, l4, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga42(l4, l4, b_set, ep)
   amp = amp + contract_b_tensor_4(coeffs) * pgb42(b_set, ep)
   mom3 = momenta((/l1,l1,l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga43(l1, l1, l1, b_set, ep)
   mom3 = momenta((/l1,l1,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l1, l2, b_set, ep)
   mom3 = momenta((/l1,l1,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l1, l3, b_set, ep)
   mom3 = momenta((/l1,l1,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l1, l4, b_set, ep)
   mom3 = momenta((/l1,l2,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l2, l2, b_set, ep)
   mom3 = momenta((/l1,l2,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l2, l3, b_set, ep)
   mom3 = momenta((/l1,l2,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l2, l4, b_set, ep)
   mom3 = momenta((/l1,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l3, l3, b_set, ep)
   mom3 = momenta((/l1,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l3, l4, b_set, ep)
   mom3 = momenta((/l1,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l1, l4, l4, b_set, ep)
   mom3 = momenta((/l2,l2,l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga43(l2, l2, l2, b_set, ep)
   mom3 = momenta((/l2,l2,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l2, l2, l3, b_set, ep)
   mom3 = momenta((/l2,l2,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l2, l2, l4, b_set, ep)
   mom3 = momenta((/l2,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l2, l3, l3, b_set, ep)
   mom3 = momenta((/l2,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l2, l3, l4, b_set, ep)
   mom3 = momenta((/l2,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l2, l4, l4, b_set, ep)
   mom3 = momenta((/l3,l3,l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga43(l3, l3, l3, b_set, ep)
   mom3 = momenta((/l3,l3,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l3, l3, l4, b_set, ep)
   mom3 = momenta((/l3,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga43(l3, l4, l4, b_set, ep)
   mom3 = momenta((/l4,l4,l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga43(l4, l4, l4, b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb43(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb43(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb43(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb43(l4, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l1, l1, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l2/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l1, l2, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l1, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l1, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l2/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l2, l2, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l2, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l2, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l1, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l2/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l2, l2, l2, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l2, l2, l3, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l2, l2, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l2, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l4/),:)
   amp = amp + 24.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l2, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l2, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l3,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l1, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l2, l2, l2, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l2, l2, l3, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l2, l2, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l2, l3, l3, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l2, l3, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l2, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l2,l3,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l2, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l3, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l3, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l3,l3,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l3, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l3,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l3, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l4,l4,l4,l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga44(l4, l4, l4, l4, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb44(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb44(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb44(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb44(l1, l4, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb44(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb44(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb44(l2, l4, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb44(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb44(l3, l4, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb44(l4, l4, b_set, ep)
   amp = amp + contract_c_tensor_4(coeffs) * pgc44(b_set, ep)
end function contract4_4
function     contract4_4s1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   if (ep .ge. 2) then
      amp = (0.0_ki_pjf, 0.0_ki_pjf)
      return
   endif
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = contract_b_tensor_2(coeffs) * pgc44(b_set, ep+1)
   ! multiply by 2
   amp = 2.0_ki*amp
end function contract4_4s1
function     contract4_4s2(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   integer :: l1, l2, l3, l4
   integer, dimension(4) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 4)
   if (ep .ge. 2) then
      amp = (0.0_ki_pjf, 0.0_ki_pjf)
      return
   endif
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   amp = coeffs%c0 * pgc44(b_set, ep+1)
   if(ep .eq. 0) then
      amp = amp - coeffs%c0 * pgc44(b_set, ep+2)
   endif
   ! multiply by -4
   amp = -4.0_ki*amp
end function contract4_4s2
function     contract5_1(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_1), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   integer :: l1, l2, l3, l4, l5
   integer, dimension(5) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 5)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   l5 = unpinched(5)
   amp = coeffs%c0 * pga50(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga51(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga51(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga51(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga51(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_a_tensor_1(coeffs, mom1) * pga51(l5, b_set, ep)
end function contract5_1
function     contract5_2(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   integer :: l1, l2, l3, l4, l5
   integer, dimension(5) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 5)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   l5 = unpinched(5)
   amp = coeffs%c0 * pga50(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga51(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga51(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga51(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga51(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom1) * pga51(l5, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga52(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l1, l4, b_set, ep)
   mom2 = momenta((/l1,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l1, l5, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga52(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l2, l4, b_set, ep)
   mom2 = momenta((/l2,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l2, l5, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga52(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l3, l4, b_set, ep)
   mom2 = momenta((/l3,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l3, l5, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga52(l4, l4, b_set, ep)
   mom2 = momenta((/l4,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_2(coeffs, mom2) &
   &  * pga52(l4, l5, b_set, ep)
   mom2 = momenta((/l5,l5/),:)
   amp = amp + contract_a_tensor_2(coeffs, mom2) * pga52(l5, l5, b_set, ep)
   amp = amp + contract_b_tensor_2(coeffs) * pgb52(b_set, ep)
end function contract5_2
function     contract5_3(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_3), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   real(ki), dimension(3,0:3) :: mom3
   integer :: l1, l2, l3, l4, l5
   integer, dimension(5) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 5)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   l5 = unpinched(5)
   amp = coeffs%c0 * pga50(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga51(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga51(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga51(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga51(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom1) * pga51(l5, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga52(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l1, l4, b_set, ep)
   mom2 = momenta((/l1,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l1, l5, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga52(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l2, l4, b_set, ep)
   mom2 = momenta((/l2,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l2, l5, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga52(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l3, l4, b_set, ep)
   mom2 = momenta((/l3,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l3, l5, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga52(l4, l4, b_set, ep)
   mom2 = momenta((/l4,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_3(coeffs, mom2) &
   &  * pga52(l4, l5, b_set, ep)
   mom2 = momenta((/l5,l5/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom2) * pga52(l5, l5, b_set, ep)
   amp = amp + contract_b_tensor_3(coeffs) * pgb52(b_set, ep)
   mom3 = momenta((/l1,l1,l1/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga53(l1, l1, l1, b_set, ep)
   mom3 = momenta((/l1,l1,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l1, l2, b_set, ep)
   mom3 = momenta((/l1,l1,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l1, l3, b_set, ep)
   mom3 = momenta((/l1,l1,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l1, l4, b_set, ep)
   mom3 = momenta((/l1,l1,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l1, l5, b_set, ep)
   mom3 = momenta((/l1,l2,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l2, l2, b_set, ep)
   mom3 = momenta((/l1,l2,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l2, l3, b_set, ep)
   mom3 = momenta((/l1,l2,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l2, l4, b_set, ep)
   mom3 = momenta((/l1,l2,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l2, l5, b_set, ep)
   mom3 = momenta((/l1,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l3, l3, b_set, ep)
   mom3 = momenta((/l1,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l3, l4, b_set, ep)
   mom3 = momenta((/l1,l3,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l3, l5, b_set, ep)
   mom3 = momenta((/l1,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l4, l4, b_set, ep)
   mom3 = momenta((/l1,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l4, l5, b_set, ep)
   mom3 = momenta((/l1,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l1, l5, l5, b_set, ep)
   mom3 = momenta((/l2,l2,l2/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga53(l2, l2, l2, b_set, ep)
   mom3 = momenta((/l2,l2,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l2, l3, b_set, ep)
   mom3 = momenta((/l2,l2,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l2, l4, b_set, ep)
   mom3 = momenta((/l2,l2,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l2, l5, b_set, ep)
   mom3 = momenta((/l2,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l3, l3, b_set, ep)
   mom3 = momenta((/l2,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l3, l4, b_set, ep)
   mom3 = momenta((/l2,l3,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l3, l5, b_set, ep)
   mom3 = momenta((/l2,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l4, l4, b_set, ep)
   mom3 = momenta((/l2,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l4, l5, b_set, ep)
   mom3 = momenta((/l2,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l2, l5, l5, b_set, ep)
   mom3 = momenta((/l3,l3,l3/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga53(l3, l3, l3, b_set, ep)
   mom3 = momenta((/l3,l3,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l3, l3, l4, b_set, ep)
   mom3 = momenta((/l3,l3,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l3, l3, l5, b_set, ep)
   mom3 = momenta((/l3,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l3, l4, l4, b_set, ep)
   mom3 = momenta((/l3,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l3, l4, l5, b_set, ep)
   mom3 = momenta((/l3,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l3, l5, l5, b_set, ep)
   mom3 = momenta((/l4,l4,l4/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga53(l4, l4, l4, b_set, ep)
   mom3 = momenta((/l4,l4,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l4, l4, l5, b_set, ep)
   mom3 = momenta((/l4,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_3(coeffs, mom3) &
   &  * pga53(l4, l5, l5, b_set, ep)
   mom3 = momenta((/l5,l5,l5/),:)
   amp = amp + contract_a_tensor_3(coeffs, mom3) * pga53(l5, l5, l5, b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb53(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb53(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb53(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb53(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_b_tensor_3(coeffs, mom1) * pgb53(l5, b_set, ep)
end function contract5_3
function     contract5_4(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_4), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   real(ki), dimension(3,0:3) :: mom3
   real(ki), dimension(4,0:3) :: mom4
   integer :: l1, l2, l3, l4, l5
   integer, dimension(5) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 5)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   l5 = unpinched(5)
   amp = coeffs%c0 * pga50(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga51(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga51(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga51(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga51(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom1) * pga51(l5, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga52(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l1, l4, b_set, ep)
   mom2 = momenta((/l1,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l1, l5, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga52(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l2, l4, b_set, ep)
   mom2 = momenta((/l2,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l2, l5, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga52(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l3, l4, b_set, ep)
   mom2 = momenta((/l3,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l3, l5, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga52(l4, l4, b_set, ep)
   mom2 = momenta((/l4,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_4(coeffs, mom2) &
   &  * pga52(l4, l5, b_set, ep)
   mom2 = momenta((/l5,l5/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom2) * pga52(l5, l5, b_set, ep)
   amp = amp + contract_b_tensor_4(coeffs) * pgb52(b_set, ep)
   mom3 = momenta((/l1,l1,l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga53(l1, l1, l1, b_set, ep)
   mom3 = momenta((/l1,l1,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l1, l2, b_set, ep)
   mom3 = momenta((/l1,l1,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l1, l3, b_set, ep)
   mom3 = momenta((/l1,l1,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l1, l4, b_set, ep)
   mom3 = momenta((/l1,l1,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l1, l5, b_set, ep)
   mom3 = momenta((/l1,l2,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l2, l2, b_set, ep)
   mom3 = momenta((/l1,l2,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l2, l3, b_set, ep)
   mom3 = momenta((/l1,l2,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l2, l4, b_set, ep)
   mom3 = momenta((/l1,l2,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l2, l5, b_set, ep)
   mom3 = momenta((/l1,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l3, l3, b_set, ep)
   mom3 = momenta((/l1,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l3, l4, b_set, ep)
   mom3 = momenta((/l1,l3,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l3, l5, b_set, ep)
   mom3 = momenta((/l1,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l4, l4, b_set, ep)
   mom3 = momenta((/l1,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l4, l5, b_set, ep)
   mom3 = momenta((/l1,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l1, l5, l5, b_set, ep)
   mom3 = momenta((/l2,l2,l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga53(l2, l2, l2, b_set, ep)
   mom3 = momenta((/l2,l2,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l2, l3, b_set, ep)
   mom3 = momenta((/l2,l2,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l2, l4, b_set, ep)
   mom3 = momenta((/l2,l2,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l2, l5, b_set, ep)
   mom3 = momenta((/l2,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l3, l3, b_set, ep)
   mom3 = momenta((/l2,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l3, l4, b_set, ep)
   mom3 = momenta((/l2,l3,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l3, l5, b_set, ep)
   mom3 = momenta((/l2,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l4, l4, b_set, ep)
   mom3 = momenta((/l2,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l4, l5, b_set, ep)
   mom3 = momenta((/l2,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l2, l5, l5, b_set, ep)
   mom3 = momenta((/l3,l3,l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga53(l3, l3, l3, b_set, ep)
   mom3 = momenta((/l3,l3,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l3, l3, l4, b_set, ep)
   mom3 = momenta((/l3,l3,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l3, l3, l5, b_set, ep)
   mom3 = momenta((/l3,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l3, l4, l4, b_set, ep)
   mom3 = momenta((/l3,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l3, l4, l5, b_set, ep)
   mom3 = momenta((/l3,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l3, l5, l5, b_set, ep)
   mom3 = momenta((/l4,l4,l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga53(l4, l4, l4, b_set, ep)
   mom3 = momenta((/l4,l4,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l4, l4, l5, b_set, ep)
   mom3 = momenta((/l4,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_4(coeffs, mom3) &
   &  * pga53(l4, l5, l5, b_set, ep)
   mom3 = momenta((/l5,l5,l5/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom3) * pga53(l5, l5, l5, b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb53(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb53(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb53(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb53(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom1) * pgb53(l5, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l1/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l1, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l2/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l2, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l2/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l2, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l3, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l1, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l2/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l2, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l3, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l4/),:)
   amp = amp + 24.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l3, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l4,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l2, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l3, l3, l5, b_set, ep)
   mom4 = momenta((/l1,l3,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l3,l4,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l3, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l3,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l3, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l4,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l4,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l1, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l2/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l2, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l3, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l3, l3, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l3, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l3, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l4, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l2, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l3, l3, l5, b_set, ep)
   mom4 = momenta((/l2,l3,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l3,l4,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l3, l4, l5, b_set, ep)
   mom4 = momenta((/l2,l3,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l3, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l4,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l2,l4,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l2, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l3/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l3, l3, l5, b_set, ep)
   mom4 = momenta((/l3,l3,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l3,l3,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l3, l4, l5, b_set, ep)
   mom4 = momenta((/l3,l3,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l3, l5, l5, b_set, ep)
   mom4 = momenta((/l3,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l3,l4,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l3,l4,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l3,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l3, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l4,l4,l4,l4/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l4, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l4,l4,l4,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l4, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l4,l4,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l4, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l4,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l4, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l5,l5,l5,l5/),:)
   amp = amp + contract_a_tensor_4(coeffs, mom4) &
   &  * pga54(l5, l5, l5, l5, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb54(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l1, l4, b_set, ep)
   mom2 = momenta((/l1,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l1, l5, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb54(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l2, l4, b_set, ep)
   mom2 = momenta((/l2,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l2, l5, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb54(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l3, l4, b_set, ep)
   mom2 = momenta((/l3,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l3, l5, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb54(l4, l4, b_set, ep)
   mom2 = momenta((/l4,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_4(coeffs, mom2) &
   &  * pgb54(l4, l5, b_set, ep)
   mom2 = momenta((/l5,l5/),:)
   amp = amp + contract_b_tensor_4(coeffs, mom2) * pgb54(l5, l5, b_set, ep)
   amp = amp + contract_c_tensor_4(coeffs) * pgc54(b_set, ep)
end function contract5_4
function     contract5_5(coeffs, momenta, b_set, ep) result(amp)
   ! generated by: write_function_contract
   use [% process_name asprefix=\_ %]pjfry95pg
   implicit none
   type(coeff_type_5), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in) :: momenta
   integer, intent(in) :: b_set, ep
   complex(ki_pjf) :: amp
   ! generated by: write_contract_simple
   real(ki), dimension(1,0:3) :: mom1
   real(ki), dimension(2,0:3) :: mom2
   real(ki), dimension(3,0:3) :: mom3
   real(ki), dimension(4,0:3) :: mom4
   real(ki), dimension(5,0:3) :: mom5
   integer :: l1, l2, l3, l4, l5
   integer, dimension(5) :: unpinched
   unpinched = unpackb(pminus(b_ref, b_set), 5)
   l1 = unpinched(1)
   l2 = unpinched(2)
   l3 = unpinched(3)
   l4 = unpinched(4)
   l5 = unpinched(5)
   amp = coeffs%c0 * pga50(b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom1) * pga51(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom1) * pga51(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom1) * pga51(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom1) * pga51(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom1) * pga51(l5, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom2) * pga52(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l1, l4, b_set, ep)
   mom2 = momenta((/l1,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l1, l5, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom2) * pga52(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l2, l4, b_set, ep)
   mom2 = momenta((/l2,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l2, l5, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom2) * pga52(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l3, l4, b_set, ep)
   mom2 = momenta((/l3,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l3, l5, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom2) * pga52(l4, l4, b_set, ep)
   mom2 = momenta((/l4,l5/),:)
   amp = amp + 2.0_ki * contract_a_tensor_5(coeffs, mom2) &
   &  * pga52(l4, l5, b_set, ep)
   mom2 = momenta((/l5,l5/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom2) * pga52(l5, l5, b_set, ep)
   amp = amp + contract_b_tensor_5(coeffs) * pgb52(b_set, ep)
   mom3 = momenta((/l1,l1,l1/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom3) * pga53(l1, l1, l1, b_set, ep)
   mom3 = momenta((/l1,l1,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l1, l2, b_set, ep)
   mom3 = momenta((/l1,l1,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l1, l3, b_set, ep)
   mom3 = momenta((/l1,l1,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l1, l4, b_set, ep)
   mom3 = momenta((/l1,l1,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l1, l5, b_set, ep)
   mom3 = momenta((/l1,l2,l2/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l2, l2, b_set, ep)
   mom3 = momenta((/l1,l2,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l2, l3, b_set, ep)
   mom3 = momenta((/l1,l2,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l2, l4, b_set, ep)
   mom3 = momenta((/l1,l2,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l2, l5, b_set, ep)
   mom3 = momenta((/l1,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l3, l3, b_set, ep)
   mom3 = momenta((/l1,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l3, l4, b_set, ep)
   mom3 = momenta((/l1,l3,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l3, l5, b_set, ep)
   mom3 = momenta((/l1,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l4, l4, b_set, ep)
   mom3 = momenta((/l1,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l4, l5, b_set, ep)
   mom3 = momenta((/l1,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l1, l5, l5, b_set, ep)
   mom3 = momenta((/l2,l2,l2/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom3) * pga53(l2, l2, l2, b_set, ep)
   mom3 = momenta((/l2,l2,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l2, l3, b_set, ep)
   mom3 = momenta((/l2,l2,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l2, l4, b_set, ep)
   mom3 = momenta((/l2,l2,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l2, l5, b_set, ep)
   mom3 = momenta((/l2,l3,l3/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l3, l3, b_set, ep)
   mom3 = momenta((/l2,l3,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l3, l4, b_set, ep)
   mom3 = momenta((/l2,l3,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l3, l5, b_set, ep)
   mom3 = momenta((/l2,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l4, l4, b_set, ep)
   mom3 = momenta((/l2,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l4, l5, b_set, ep)
   mom3 = momenta((/l2,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l2, l5, l5, b_set, ep)
   mom3 = momenta((/l3,l3,l3/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom3) * pga53(l3, l3, l3, b_set, ep)
   mom3 = momenta((/l3,l3,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l3, l3, l4, b_set, ep)
   mom3 = momenta((/l3,l3,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l3, l3, l5, b_set, ep)
   mom3 = momenta((/l3,l4,l4/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l3, l4, l4, b_set, ep)
   mom3 = momenta((/l3,l4,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l3, l4, l5, b_set, ep)
   mom3 = momenta((/l3,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l3, l5, l5, b_set, ep)
   mom3 = momenta((/l4,l4,l4/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom3) * pga53(l4, l4, l4, b_set, ep)
   mom3 = momenta((/l4,l4,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l4, l4, l5, b_set, ep)
   mom3 = momenta((/l4,l5,l5/),:)
   amp = amp + 3.0_ki * contract_a_tensor_5(coeffs, mom3) &
   &  * pga53(l4, l5, l5, b_set, ep)
   mom3 = momenta((/l5,l5,l5/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom3) * pga53(l5, l5, l5, b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom1) * pgb53(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom1) * pgb53(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom1) * pgb53(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom1) * pgb53(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom1) * pgb53(l5, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l1/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l1, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l2/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l2, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l1,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l1, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l2/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l2, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l2,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l2, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l3, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l1,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l1,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l1, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l2/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l2, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l3, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l2,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l2, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l3/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l4/),:)
   amp = amp + 24.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l3,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l3, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l2,l4,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l2,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l2, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l1,l3,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l3, l3, l5, b_set, ep)
   mom4 = momenta((/l1,l3,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l3,l4,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l3, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l3,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l3, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l1,l4,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l1,l4,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l1,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l1, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l2/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l2, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l3, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l2,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l2, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l3/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l3, l3, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l3, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l3, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l2,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l4, l5, b_set, ep)
   mom4 = momenta((/l2,l2,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l2, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l3/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l2,l3,l3,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l3, l3, l5, b_set, ep)
   mom4 = momenta((/l2,l3,l4,l4/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l3,l4,l5/),:)
   amp = amp + 24.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l3, l4, l5, b_set, ep)
   mom4 = momenta((/l2,l3,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l3, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l2,l4,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l2,l4,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l2,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l2, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l3/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l3, l3, l3, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l3, l3, l4, b_set, ep)
   mom4 = momenta((/l3,l3,l3,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l3, l3, l5, b_set, ep)
   mom4 = momenta((/l3,l3,l4,l4/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l3, l4, l4, b_set, ep)
   mom4 = momenta((/l3,l3,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l3, l4, l5, b_set, ep)
   mom4 = momenta((/l3,l3,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l3, l5, l5, b_set, ep)
   mom4 = momenta((/l3,l4,l4,l4/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l3,l4,l4,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l3,l4,l5,l5/),:)
   amp = amp + 12.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l3,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l3, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l4,l4,l4,l4/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l4, l4, l4, l4, b_set, ep)
   mom4 = momenta((/l4,l4,l4,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l4, l4, l4, l5, b_set, ep)
   mom4 = momenta((/l4,l4,l5,l5/),:)
   amp = amp + 6.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l4, l4, l5, l5, b_set, ep)
   mom4 = momenta((/l4,l5,l5,l5/),:)
   amp = amp + 4.0_ki * contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l4, l5, l5, l5, b_set, ep)
   mom4 = momenta((/l5,l5,l5,l5/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom4) &
   &  * pga54(l5, l5, l5, l5, b_set, ep)
   mom2 = momenta((/l1,l1/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom2) * pgb54(l1, l1, b_set, ep)
   mom2 = momenta((/l1,l2/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l1, l2, b_set, ep)
   mom2 = momenta((/l1,l3/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l1, l3, b_set, ep)
   mom2 = momenta((/l1,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l1, l4, b_set, ep)
   mom2 = momenta((/l1,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l1, l5, b_set, ep)
   mom2 = momenta((/l2,l2/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom2) * pgb54(l2, l2, b_set, ep)
   mom2 = momenta((/l2,l3/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l2, l3, b_set, ep)
   mom2 = momenta((/l2,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l2, l4, b_set, ep)
   mom2 = momenta((/l2,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l2, l5, b_set, ep)
   mom2 = momenta((/l3,l3/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom2) * pgb54(l3, l3, b_set, ep)
   mom2 = momenta((/l3,l4/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l3, l4, b_set, ep)
   mom2 = momenta((/l3,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l3, l5, b_set, ep)
   mom2 = momenta((/l4,l4/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom2) * pgb54(l4, l4, b_set, ep)
   mom2 = momenta((/l4,l5/),:)
   amp = amp + 2.0_ki * contract_b_tensor_5(coeffs, mom2) &
   &  * pgb54(l4, l5, b_set, ep)
   mom2 = momenta((/l5,l5/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom2) * pgb54(l5, l5, b_set, ep)
   amp = amp + contract_c_tensor_5(coeffs) * pgc54(b_set, ep)
   mom5 = momenta((/l1,l1,l1,l1,l1/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l1, l1, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l1,l2/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l1, l2, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l1,l3/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l1, l3, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l1,l4/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l1, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l1,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l1, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l2,l2/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l2, l2, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l2,l3/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l2, l3, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l2,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l2, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l2,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l2, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l3,l3/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l3, l3, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l3,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l3, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l3,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l3, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l4,l4/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l4,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l1,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l1, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l2,l2/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l2, l2, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l2,l3/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l2, l3, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l2,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l2, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l2,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l2, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l3,l3/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l3, l3, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l3,l4/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l3, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l3,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l3, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l4,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l2,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l2, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l3,l3,l3/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l3, l3, l3, b_set, ep)
   mom5 = momenta((/l1,l1,l3,l3,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l3, l3, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l3,l3,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l3, l3, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l3,l4,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l3, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l3,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l3, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l3,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l3, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l4,l4,l4/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l1,l4,l4,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l4,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l1,l5,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l1, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l2,l2/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l2, l2, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l2,l3/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l2, l3, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l2,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l2, l4, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l2,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l2, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l3,l3/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l3, l3, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l3,l4/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l3, l4, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l3,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l3, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l4,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l2,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l2, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l3,l3,l3/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l3, l3, l3, b_set, ep)
   mom5 = momenta((/l1,l2,l3,l3,l4/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l3, l3, l4, b_set, ep)
   mom5 = momenta((/l1,l2,l3,l3,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l3, l3, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l3,l4,l4/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l3, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l2,l3,l4,l5/),:)
   amp = amp + 120.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l3, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l3,l5,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l3, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l4,l4,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l2,l4,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l4,l5,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l2,l5,l5,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l2, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l3,l3,l3,l3/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l3, l3, l3, b_set, ep)
   mom5 = momenta((/l1,l3,l3,l3,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l3, l3, l4, b_set, ep)
   mom5 = momenta((/l1,l3,l3,l3,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l3, l3, l5, b_set, ep)
   mom5 = momenta((/l1,l3,l3,l4,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l3, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l3,l3,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l3, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l3,l3,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l3, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l3,l4,l4,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l3,l4,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l3,l4,l5,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l3,l5,l5,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l3, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l4,l4,l4,l4/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l4, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l1,l4,l4,l4,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l4, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l1,l4,l4,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l4, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l4,l5,l5,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l4, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l1,l5,l5,l5,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l1, l5, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l2,l2/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l2, l2, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l2,l3/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l2, l3, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l2,l4/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l2, l4, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l2,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l2, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l3,l3/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l3, l3, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l3,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l3, l4, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l3,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l3, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l4,l4/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l4, l4, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l4,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l4, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l2,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l2, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l3,l3,l3/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l3, l3, l3, b_set, ep)
   mom5 = momenta((/l2,l2,l3,l3,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l3, l3, l4, b_set, ep)
   mom5 = momenta((/l2,l2,l3,l3,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l3, l3, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l3,l4,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l3, l4, l4, b_set, ep)
   mom5 = momenta((/l2,l2,l3,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l3, l4, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l3,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l3, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l4,l4,l4/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l2,l2,l4,l4,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l4,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l2,l5,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l2, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l3,l3,l3,l3/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l3, l3, l3, b_set, ep)
   mom5 = momenta((/l2,l3,l3,l3,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l3, l3, l4, b_set, ep)
   mom5 = momenta((/l2,l3,l3,l3,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l3, l3, l5, b_set, ep)
   mom5 = momenta((/l2,l3,l3,l4,l4/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l3, l4, l4, b_set, ep)
   mom5 = momenta((/l2,l3,l3,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l3, l4, l5, b_set, ep)
   mom5 = momenta((/l2,l3,l3,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l3, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l3,l4,l4,l4/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l2,l3,l4,l4,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l2,l3,l4,l5,l5/),:)
   amp = amp + 60.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l3,l5,l5,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l3, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l4,l4,l4,l4/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l4, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l2,l4,l4,l4,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l4, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l2,l4,l4,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l4, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l4,l5,l5,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l4, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l2,l5,l5,l5,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l2, l5, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l3,l3,l3,l3,l3/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l3, l3, l3, b_set, ep)
   mom5 = momenta((/l3,l3,l3,l3,l4/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l3, l3, l4, b_set, ep)
   mom5 = momenta((/l3,l3,l3,l3,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l3, l3, l5, b_set, ep)
   mom5 = momenta((/l3,l3,l3,l4,l4/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l3, l4, l4, b_set, ep)
   mom5 = momenta((/l3,l3,l3,l4,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l3, l4, l5, b_set, ep)
   mom5 = momenta((/l3,l3,l3,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l3, l5, l5, b_set, ep)
   mom5 = momenta((/l3,l3,l4,l4,l4/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l3,l3,l4,l4,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l3,l3,l4,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l3,l3,l5,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l3, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l3,l4,l4,l4,l4/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l4, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l3,l4,l4,l4,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l4, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l3,l4,l4,l5,l5/),:)
   amp = amp + 30.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l4, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l3,l4,l5,l5,l5/),:)
   amp = amp + 20.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l4, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l3,l5,l5,l5,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l3, l5, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l4,l4,l4,l4,l4/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l4, l4, l4, l4, l4, b_set, ep)
   mom5 = momenta((/l4,l4,l4,l4,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l4, l4, l4, l4, l5, b_set, ep)
   mom5 = momenta((/l4,l4,l4,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l4, l4, l4, l5, l5, b_set, ep)
   mom5 = momenta((/l4,l4,l5,l5,l5/),:)
   amp = amp + 10.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l4, l4, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l4,l5,l5,l5,l5/),:)
   amp = amp + 5.0_ki * contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l4, l5, l5, l5, l5, b_set, ep)
   mom5 = momenta((/l5,l5,l5,l5,l5/),:)
   amp = amp + contract_a_tensor_5(coeffs, mom5) &
   &  * pga55(l5, l5, l5, l5, l5, b_set, ep)
   mom3 = momenta((/l1,l1,l1/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom3) * pgb55(l1, l1, l1, b_set, ep)
   mom3 = momenta((/l1,l1,l2/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l1, l2, b_set, ep)
   mom3 = momenta((/l1,l1,l3/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l1, l3, b_set, ep)
   mom3 = momenta((/l1,l1,l4/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l1, l4, b_set, ep)
   mom3 = momenta((/l1,l1,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l1, l5, b_set, ep)
   mom3 = momenta((/l1,l2,l2/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l2, l2, b_set, ep)
   mom3 = momenta((/l1,l2,l3/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l2, l3, b_set, ep)
   mom3 = momenta((/l1,l2,l4/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l2, l4, b_set, ep)
   mom3 = momenta((/l1,l2,l5/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l2, l5, b_set, ep)
   mom3 = momenta((/l1,l3,l3/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l3, l3, b_set, ep)
   mom3 = momenta((/l1,l3,l4/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l3, l4, b_set, ep)
   mom3 = momenta((/l1,l3,l5/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l3, l5, b_set, ep)
   mom3 = momenta((/l1,l4,l4/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l4, l4, b_set, ep)
   mom3 = momenta((/l1,l4,l5/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l4, l5, b_set, ep)
   mom3 = momenta((/l1,l5,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l1, l5, l5, b_set, ep)
   mom3 = momenta((/l2,l2,l2/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom3) * pgb55(l2, l2, l2, b_set, ep)
   mom3 = momenta((/l2,l2,l3/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l2, l3, b_set, ep)
   mom3 = momenta((/l2,l2,l4/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l2, l4, b_set, ep)
   mom3 = momenta((/l2,l2,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l2, l5, b_set, ep)
   mom3 = momenta((/l2,l3,l3/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l3, l3, b_set, ep)
   mom3 = momenta((/l2,l3,l4/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l3, l4, b_set, ep)
   mom3 = momenta((/l2,l3,l5/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l3, l5, b_set, ep)
   mom3 = momenta((/l2,l4,l4/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l4, l4, b_set, ep)
   mom3 = momenta((/l2,l4,l5/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l4, l5, b_set, ep)
   mom3 = momenta((/l2,l5,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l2, l5, l5, b_set, ep)
   mom3 = momenta((/l3,l3,l3/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom3) * pgb55(l3, l3, l3, b_set, ep)
   mom3 = momenta((/l3,l3,l4/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l3, l3, l4, b_set, ep)
   mom3 = momenta((/l3,l3,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l3, l3, l5, b_set, ep)
   mom3 = momenta((/l3,l4,l4/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l3, l4, l4, b_set, ep)
   mom3 = momenta((/l3,l4,l5/),:)
   amp = amp + 6.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l3, l4, l5, b_set, ep)
   mom3 = momenta((/l3,l5,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l3, l5, l5, b_set, ep)
   mom3 = momenta((/l4,l4,l4/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom3) * pgb55(l4, l4, l4, b_set, ep)
   mom3 = momenta((/l4,l4,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l4, l4, l5, b_set, ep)
   mom3 = momenta((/l4,l5,l5/),:)
   amp = amp + 3.0_ki * contract_b_tensor_5(coeffs, mom3) &
   &  * pgb55(l4, l5, l5, b_set, ep)
   mom3 = momenta((/l5,l5,l5/),:)
   amp = amp + contract_b_tensor_5(coeffs, mom3) * pgb55(l5, l5, l5, b_set, ep)
   mom1 = momenta((/l1/),:)
   amp = amp + contract_c_tensor_5(coeffs, mom1) * pgc55(l1, b_set, ep)
   mom1 = momenta((/l2/),:)
   amp = amp + contract_c_tensor_5(coeffs, mom1) * pgc55(l2, b_set, ep)
   mom1 = momenta((/l3/),:)
   amp = amp + contract_c_tensor_5(coeffs, mom1) * pgc55(l3, b_set, ep)
   mom1 = momenta((/l4/),:)
   amp = amp + contract_c_tensor_5(coeffs, mom1) * pgc55(l4, b_set, ep)
   mom1 = momenta((/l5/),:)
   amp = amp + contract_c_tensor_5(coeffs, mom1) * pgc55(l5, b_set, ep)
end function contract5_5
pure function contract_a_tensor_1(coeffs, momenta) result(res)
   ! generated by: write_function_a_tensor_contract
   implicit none
   type(coeff_type_1), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(1)
      acc = momenta(1,0)
      res = acc * coeffs%c1(1,1)
      acc = momenta(1,1)
      res = res + acc * coeffs%c1(2,1)
      acc = momenta(1,2)
      res = res + acc * coeffs%c1(3,1)
      acc = momenta(1,3)
      res = res + acc * coeffs%c1(4,1)
   case default
      res = 0.0_ki
   end select
end  function contract_a_tensor_1
pure function contract_a_tensor_2(coeffs, momenta) result(res)
   ! generated by: write_function_a_tensor_contract
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(1)
      acc = momenta(1,0)
      res = acc * coeffs%c1(1,1)
      acc = momenta(1,1)
      res = res + acc * coeffs%c1(2,1)
      acc = momenta(1,2)
      res = res + acc * coeffs%c1(3,1)
      acc = momenta(1,3)
      res = res + acc * coeffs%c1(4,1)
   case(2)
      acc = momenta(1,0)*momenta(2,0)
      res = acc * coeffs%c1(1,2)
      acc = momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c1(2,2)
      acc = momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c1(3,2)
      acc = momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c1(4,2)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,1)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,1)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,1)
   case default
      res = 0.0_ki
   end select
end  function contract_a_tensor_2
pure function contract_b_tensor_2(coeffs, momenta) result(res)
   ! generated by: write_function_b_tensor_contract
   implicit none
   type(coeff_type_2), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(0)
      res = coeffs%c1(1,2)
      res = res - coeffs%c1(2,2)
      res = res - coeffs%c1(3,2)
      res = res - coeffs%c1(4,2)
   case default
      res = 0.0_ki
   end select
end  function contract_b_tensor_2
pure function contract_a_tensor_3(coeffs, momenta) result(res)
   ! generated by: write_function_a_tensor_contract
   implicit none
   type(coeff_type_3), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   real(ki) :: reg0
   real(ki) :: reg1
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(1)
      acc = momenta(1,0)
      res = acc * coeffs%c1(1,1)
      acc = momenta(1,1)
      res = res + acc * coeffs%c1(2,1)
      acc = momenta(1,2)
      res = res + acc * coeffs%c1(3,1)
      acc = momenta(1,3)
      res = res + acc * coeffs%c1(4,1)
   case(2)
      acc = momenta(1,0)*momenta(2,0)
      res = acc * coeffs%c1(1,2)
      acc = momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c1(2,2)
      acc = momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c1(3,2)
      acc = momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c1(4,2)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,1)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,1)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,1)
   case(3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = acc * coeffs%c2(1,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,2)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,2)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,2)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(1,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(2,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(3,1)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(4,1)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)
      res = res + acc * coeffs%c1(1,3)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)
      res = res + acc * coeffs%c1(2,3)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)
      res = res + acc * coeffs%c1(3,3)
      acc = momenta(1,3)*momenta(2,3)*momenta(3,3)
      res = res + acc * coeffs%c1(4,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,3)
   case default
      res = 0.0_ki
   end select
end  function contract_a_tensor_3
pure function contract_b_tensor_3(coeffs, momenta) result(res)
   ! generated by: write_function_b_tensor_contract
   implicit none
   type(coeff_type_3), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(0)
      res = coeffs%c1(1,2)
      res = res - coeffs%c1(2,2)
      res = res - coeffs%c1(3,2)
      res = res - coeffs%c1(4,2)
   case(1)
      acc = -momenta(1,0)
      res = acc * coeffs%c2(1,2)
      acc = -momenta(1,0)
      res = res + acc * coeffs%c2(2,2)
      acc = -momenta(1,0)
      res = res + acc * coeffs%c2(3,2)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c2(4,2)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c2(5,2)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c2(6,2)
      acc = 3*momenta(1,0)
      res = res + acc * coeffs%c1(1,3)
      acc = -3*momenta(1,1)
      res = res + acc * coeffs%c1(2,3)
      acc = -3*momenta(1,2)
      res = res + acc * coeffs%c1(3,3)
      acc = -3*momenta(1,3)
      res = res + acc * coeffs%c1(4,3)
      acc = momenta(1,1)
      res = res + acc * coeffs%c2(1,3)
      acc = momenta(1,2)
      res = res + acc * coeffs%c2(2,3)
      acc = momenta(1,3)
      res = res + acc * coeffs%c2(3,3)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c2(4,3)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c2(5,3)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c2(6,3)
   case default
      res = 0.0_ki
   end select
end  function contract_b_tensor_3
pure function contract_a_tensor_4(coeffs, momenta) result(res)
   ! generated by: write_function_a_tensor_contract
   implicit none
   type(coeff_type_4), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   real(ki) :: reg4
   real(ki) :: reg5
   real(ki) :: reg2
   real(ki) :: reg3
   real(ki) :: reg0
   real(ki) :: reg1
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(1)
      acc = momenta(1,0)
      res = acc * coeffs%c1(1,1)
      acc = momenta(1,1)
      res = res + acc * coeffs%c1(2,1)
      acc = momenta(1,2)
      res = res + acc * coeffs%c1(3,1)
      acc = momenta(1,3)
      res = res + acc * coeffs%c1(4,1)
   case(2)
      acc = momenta(1,0)*momenta(2,0)
      res = acc * coeffs%c1(1,2)
      acc = momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c1(2,2)
      acc = momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c1(3,2)
      acc = momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c1(4,2)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,1)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,1)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,1)
   case(3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = acc * coeffs%c2(1,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,2)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,2)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,2)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(1,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(2,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(3,1)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(4,1)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)
      res = res + acc * coeffs%c1(1,3)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)
      res = res + acc * coeffs%c1(2,3)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)
      res = res + acc * coeffs%c1(3,3)
      acc = momenta(1,3)*momenta(2,3)*momenta(3,3)
      res = res + acc * coeffs%c1(4,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(1,4)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,4)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,4)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,4)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,4)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,4)
   case(4)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,2)
      acc = acc + reg2
      reg1 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = acc * coeffs%c3(1,3)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      reg1 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(2,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(3,3)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,0)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(2,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,0)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(3,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(4,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(5,3)
      acc = momenta(2,2)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,2)
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(6,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,2)
      acc = acc + momenta(3,2)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(1,4)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(2,4)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(3,2)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,2)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(3,4)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      reg1 = acc * momenta(2,1)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(4,4)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,1)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(1,6)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,2)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(2,6)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,3)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(3,6)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,2)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(4,6)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,3)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(5,6)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(6,6)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg4 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(2,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg5 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      acc = acc * momenta(1,2)
      acc = acc + reg2
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 24.0_ki
      res = res + acc * coeffs%c4(1,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,1)
      acc = acc + momenta(3,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(1,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg1 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg2 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,1)
      acc = acc + momenta(1,1)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(2,2)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(3,2)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg1 = acc * momenta(4,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg2
      acc = acc * momenta(3,1)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(1,5)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg2
      acc = acc * momenta(4,0)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(2,5)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg2
      acc = acc * momenta(3,3)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(3,5)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg2
      acc = acc * momenta(4,1)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(4,5)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg1 = acc * momenta(3,1)
      acc = momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg2
      acc = acc * momenta(1,1)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(5,5)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg2
      acc = acc * momenta(4,3)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(6,5)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)*momenta(4,0)
      res = res + acc * coeffs%c1(1,4)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)*momenta(4,1)
      res = res + acc * coeffs%c1(2,4)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,2)
      res = res + acc * coeffs%c1(3,4)
      acc = momenta(1,3)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      res = res + acc * coeffs%c1(4,4)
   case default
      res = 0.0_ki
   end select
end  function contract_a_tensor_4
pure function contract_b_tensor_4(coeffs, momenta) result(res)
   ! generated by: write_function_b_tensor_contract
   implicit none
   type(coeff_type_4), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(0)
      res = coeffs%c1(1,2)
      res = res - coeffs%c1(2,2)
      res = res - coeffs%c1(3,2)
      res = res - coeffs%c1(4,2)
   case(1)
      acc = -momenta(1,0)
      res = acc * coeffs%c2(1,2)
      acc = -momenta(1,0)
      res = res + acc * coeffs%c2(2,2)
      acc = -momenta(1,0)
      res = res + acc * coeffs%c2(3,2)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c2(4,2)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c2(5,2)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c2(6,2)
      acc = 3*momenta(1,0)
      res = res + acc * coeffs%c1(1,3)
      acc = -3*momenta(1,1)
      res = res + acc * coeffs%c1(2,3)
      acc = -3*momenta(1,2)
      res = res + acc * coeffs%c1(3,3)
      acc = -3*momenta(1,3)
      res = res + acc * coeffs%c1(4,3)
      acc = momenta(1,1)
      res = res + acc * coeffs%c2(1,4)
      acc = momenta(1,2)
      res = res + acc * coeffs%c2(2,4)
      acc = momenta(1,3)
      res = res + acc * coeffs%c2(3,4)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c2(4,4)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c2(5,4)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c2(6,4)
   case(2)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = acc * coeffs%c3(1,3)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(2,3)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(3,3)
      acc = -momenta(1,1)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(4,3)
      acc = -3*momenta(1,0)*momenta(2,1)
      acc = acc - 3*momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,3)
      acc = -3*momenta(1,0)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,3)
      acc = -3*momenta(1,0)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,3)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,3)
      acc = -3*momenta(1,1)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,3)
      acc = -3*momenta(1,2)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(1,4)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(2,4)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(3,4)
      acc = -momenta(1,2)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(4,4)
      acc = 3*momenta(1,0)*momenta(2,1)
      acc = acc + 3*momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,6)
      acc = 3*momenta(1,0)*momenta(2,2)
      acc = acc + 3*momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,6)
      acc = 3*momenta(1,0)*momenta(2,3)
      acc = acc + 3*momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,6)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,6)
      acc = -3*momenta(1,1)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,6)
      acc = -3*momenta(1,2)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,6)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(1,2)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(2,2)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(3,2)
      acc = -momenta(1,1)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(4,2)
      acc = momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c2(1,5)
      acc = momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c2(2,5)
      acc = momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c2(3,5)
      acc = -momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c2(4,5)
      acc = -momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c2(5,5)
      acc = -momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c2(6,5)
      acc = -momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c2(1,5)
      acc = -momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c2(2,5)
      acc = -momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c2(3,5)
      acc = -momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c2(4,5)
      acc = -momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c2(5,5)
      acc = -momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c2(6,5)
      acc = 6*momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c1(1,4)
      acc = -6*momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c1(2,4)
      acc = -6*momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c1(3,4)
      acc = -6*momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c1(4,4)
   case default
      res = 0.0_ki
   end select
end  function contract_b_tensor_4
pure function contract_c_tensor_4(coeffs, momenta) result(res)
   ! generated by: write_function_c_tensor_contract
   implicit none
   type(coeff_type_4), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(0)
      res = -coeffs%c2(1,5)
      res = res - coeffs%c2(2,5)
      res = res - coeffs%c2(3,5)
      res = res + coeffs%c2(4,5)
      res = res + coeffs%c2(5,5)
      res = res + coeffs%c2(6,5)
      acc = 3
      res = res + acc * coeffs%c1(1,4)
      acc = 3
      res = res + acc * coeffs%c1(2,4)
      acc = 3
      res = res + acc * coeffs%c1(3,4)
      acc = 3
      res = res + acc * coeffs%c1(4,4)
   case default
      res = 0.0_ki
   end select
end  function contract_c_tensor_4
pure function contract_a_tensor_5(coeffs, momenta) result(res)
   ! generated by: write_function_a_tensor_contract
   implicit none
   type(coeff_type_5), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   real(ki) :: reg6
   real(ki) :: reg4
   real(ki) :: reg5
   real(ki) :: reg2
   real(ki) :: reg3
   real(ki) :: reg0
   real(ki) :: reg1
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(1)
      acc = momenta(1,0)
      res = acc * coeffs%c1(1,1)
      acc = momenta(1,1)
      res = res + acc * coeffs%c1(2,1)
      acc = momenta(1,2)
      res = res + acc * coeffs%c1(3,1)
      acc = momenta(1,3)
      res = res + acc * coeffs%c1(4,1)
   case(2)
      acc = momenta(1,0)*momenta(2,0)
      res = acc * coeffs%c1(1,2)
      acc = momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c1(2,2)
      acc = momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c1(3,2)
      acc = momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c1(4,2)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,1)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,1)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,1)
   case(3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = acc * coeffs%c2(1,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,2)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,2)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,2)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(1,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(2,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(3,1)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(4,1)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)
      res = res + acc * coeffs%c1(1,3)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)
      res = res + acc * coeffs%c1(2,3)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)
      res = res + acc * coeffs%c1(3,3)
      acc = momenta(1,3)*momenta(2,3)*momenta(3,3)
      res = res + acc * coeffs%c1(4,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(1,5)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,5)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,5)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,5)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,5)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,5)
   case(4)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,2)
      acc = acc + reg2
      reg1 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = acc * coeffs%c3(1,4)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      reg1 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(2,4)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(3,4)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(4,4)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,0)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(2,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,0)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(3,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(4,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(5,3)
      acc = momenta(2,2)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,2)
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(6,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,2)
      acc = acc + momenta(3,2)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(1,7)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(2,7)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(3,2)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,2)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(3,7)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg1 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(3,3)
      acc = acc + reg2
      reg1 = acc * momenta(2,1)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(4,7)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,1)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(1,8)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,2)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(2,8)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,3)*momenta(4,0)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(3,8)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,2)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(4,8)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,3)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(5,8)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,3)
      acc = acc + reg0
      acc = acc / 4.0_ki
      res = res + acc * coeffs%c2(6,8)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg4 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(2,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg5 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      acc = acc * momenta(1,2)
      acc = acc + reg2
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 24.0_ki
      res = res + acc * coeffs%c4(1,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,1)
      acc = acc + momenta(3,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(1,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg1 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg2 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,1)
      acc = acc + momenta(1,1)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(2,2)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      reg1 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(3,2)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg1 = acc * momenta(4,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(4,3)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(2,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 12.0_ki
      res = res + acc * coeffs%c3(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg1 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg2
      acc = acc * momenta(3,1)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(1,6)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg2
      acc = acc * momenta(4,0)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(2,6)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg2
      acc = acc * momenta(3,3)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(3,6)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg2
      acc = acc * momenta(4,1)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(4,6)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg1 = acc * momenta(3,1)
      acc = momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg2
      acc = acc * momenta(1,1)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(5,6)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg1 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg2
      acc = acc * momenta(4,3)
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c2(6,6)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)*momenta(4,0)
      res = res + acc * coeffs%c1(1,4)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)*momenta(4,1)
      res = res + acc * coeffs%c1(2,4)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,2)
      res = res + acc * coeffs%c1(3,4)
      acc = momenta(1,3)*momenta(2,3)*momenta(3,3)*momenta(4,3)
      res = res + acc * coeffs%c1(4,4)
   case(5)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg3
      acc = acc * momenta(3,1)
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,1)*momenta(4,0)
      acc = acc + reg2
      acc = acc * momenta(5,1)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = acc * coeffs%c2(1,9)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg2
      reg1 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg3
      acc = acc * momenta(4,0)
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,2)
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)*momenta(4,0)
      acc = acc + reg2
      acc = acc * momenta(5,2)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(2,9)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(4,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg3 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg3
      acc = acc * momenta(3,3)
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg3 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,3)*momenta(4,0)
      acc = acc + reg2
      acc = acc * momenta(5,3)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(3,9)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg2
      reg1 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg3
      acc = acc * momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg3 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,2)*momenta(4,1)
      acc = acc + reg3
      reg2 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)*momenta(4,1)
      acc = acc + reg2
      acc = acc * momenta(5,2)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(4,9)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,1)
      acc = momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg3 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg3
      acc = acc * momenta(1,1)
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg3 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,3)*momenta(4,1)
      acc = acc + reg3
      reg2 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg2
      acc = acc * momenta(5,3)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(5,9)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg2 = acc * momenta(3,2)
      acc = momenta(2,2)*momenta(3,3)*momenta(5,2)
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg3 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(5,3)
      acc = acc + reg3
      acc = acc * momenta(1,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg3 = acc * momenta(5,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(5,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)*momenta(5,2)
      acc = acc + reg2
      acc = acc * momenta(4,3)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(6,9)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg3 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      reg2 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,2)
      acc = acc + momenta(3,2)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(4,0)
      acc = momenta(4,1)*momenta(5,2)
      acc = acc + momenta(4,2)*momenta(5,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(3,1)*momenta(5,2)
      acc = acc + momenta(3,2)*momenta(5,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc * momenta(4,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(1,10)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      reg2 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg3 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,3)
      acc = acc + reg3
      reg2 = acc * momenta(4,0)
      acc = momenta(4,1)*momenta(5,3)
      acc = acc + momenta(4,3)*momenta(5,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(3,1)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc * momenta(4,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(2,10)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg3
      reg2 = acc * momenta(4,0)
      acc = momenta(3,2)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,2)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(4,0)
      acc = momenta(4,2)*momenta(5,3)
      acc = acc + momenta(4,3)*momenta(5,2)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(3,2)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,2)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc * momenta(4,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(3,10)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg2 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(3,3)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(3,2)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,2)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc * momenta(2,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(4,10)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg2 = acc * momenta(5,0)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      reg3 = acc * momenta(5,1)
      acc = momenta(2,0)*momenta(3,1)
      acc = acc + momenta(2,1)*momenta(3,0)
      acc = acc * momenta(5,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg4 = acc * momenta(5,1)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(5,3)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg5 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(5,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      reg5 = acc * momenta(5,0)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      reg6 = acc * momenta(5,1)
      acc = momenta(3,0)*momenta(4,1)
      acc = acc + momenta(3,1)*momenta(4,0)
      acc = acc * momenta(5,3)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg5 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(5,1)
      acc = acc + momenta(1,1)*momenta(5,0)
      reg5 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg6 = acc * momenta(5,2)
      acc = momenta(4,0)*momenta(5,1)
      acc = acc + momenta(4,1)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg5 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      reg5 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,0)
      reg6 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(3,1)
      acc = acc + momenta(1,1)*momenta(3,0)
      acc = acc * momenta(5,2)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(3,1)
      acc = acc + momenta(1,1)*momenta(3,0)
      reg5 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg6 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,1)
      acc = acc + momenta(3,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 60.0_ki
      res = res + acc * coeffs%c4(1,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      reg2 = acc * momenta(5,2)
      acc = momenta(3,0)*momenta(5,1)
      acc = acc + momenta(3,1)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg3 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg3
      reg2 = acc * momenta(5,2)
      acc = momenta(4,0)*momenta(5,1)
      acc = acc + momenta(4,1)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,1)
      acc = acc + momenta(3,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc * momenta(5,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(1,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(5,0)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg3 = acc * momenta(5,1)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(5,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(2,1)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(3,0)*momenta(4,1)
      acc = acc + momenta(3,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(5,1)
      acc = acc + momenta(1,1)*momenta(5,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,1)
      acc = acc + momenta(1,1)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(2,3)
      acc = momenta(2,0)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,0)
      reg2 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(5,2)
      acc = acc + momenta(2,2)*momenta(5,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      acc = acc * momenta(4,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg3 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,0)
      acc = acc * momenta(3,2)
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(3,0)*momenta(4,2)
      acc = acc + momenta(3,2)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(5,2)
      acc = acc + momenta(1,2)*momenta(5,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(3,3)
      acc = momenta(2,1)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,1)
      reg2 = acc * momenta(4,2)
      acc = momenta(2,1)*momenta(5,2)
      acc = acc + momenta(2,2)*momenta(5,1)
      reg3 = acc * momenta(4,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      acc = acc * momenta(4,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(2,1)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,1)
      reg3 = acc * momenta(3,2)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(3,1)*momenta(4,2)
      acc = acc + momenta(3,2)*momenta(4,1)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(5,2)
      acc = acc + momenta(1,2)*momenta(5,1)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(4,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg3 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg5 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(2,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg5 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg6 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,2)
      acc = acc + reg3
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg3 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg5 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(5,3)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg5 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg6 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,2)*momenta(3,3)
      acc = acc + momenta(1,3)*momenta(3,2)
      reg4 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      reg5 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(3,3)
      acc = acc + momenta(1,3)*momenta(3,1)
      acc = acc * momenta(5,2)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(2,0)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg5 = acc * momenta(5,1)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg6 = acc * momenta(5,3)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      acc = acc * momenta(5,2)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,0)
      acc = acc + reg3
      reg2 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,1)
      reg5 = acc * momenta(4,2)
      acc = momenta(4,1)*momenta(5,3)
      acc = acc + momenta(4,3)*momenta(5,1)
      reg6 = acc * momenta(3,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(5,2)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 60.0_ki
      res = res + acc * coeffs%c4(1,5)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,0)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg5 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg5 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg6 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg4 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg5 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(4,1)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg5 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg6 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc * momenta(5,2)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(4,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg5 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(2,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg5 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg6 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,2)
      acc = acc + reg3
      reg2 = acc * momenta(5,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      reg5 = acc * momenta(5,0)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      reg6 = acc * momenta(5,1)
      acc = momenta(3,0)*momenta(4,1)
      acc = acc + momenta(3,1)*momenta(4,0)
      acc = acc * momenta(5,3)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 60.0_ki
      res = res + acc * coeffs%c4(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg3 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,2)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(5,2)
      acc = acc + momenta(2,2)*momenta(5,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(3,0)*momenta(5,2)
      acc = acc + momenta(3,2)*momenta(5,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc * momenta(2,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(1,6)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,3)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(5,3)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(3,0)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc * momenta(2,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(2,6)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg2 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg3
      reg2 = acc * momenta(5,2)
      acc = momenta(3,0)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg3
      reg2 = acc * momenta(5,2)
      acc = momenta(4,0)*momenta(5,3)
      acc = acc + momenta(4,3)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc * momenta(5,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(3,6)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg2 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(3,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      reg2 = acc * momenta(5,2)
      acc = momenta(3,1)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,1)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg3
      reg2 = acc * momenta(5,2)
      acc = momenta(4,1)*momenta(5,3)
      acc = acc + momenta(4,3)*momenta(5,1)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc * momenta(5,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 20.0_ki
      res = res + acc * coeffs%c3(4,6)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,0)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)*momenta(4,1)*momenta(5,0)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(1,4)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(5,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(5,0)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)*momenta(5,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,0)*momenta(5,2)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(2,4)
      acc = momenta(2,0)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,0)
      reg2 = acc * momenta(4,3)
      acc = momenta(2,3)*momenta(4,0)*momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,0)*momenta(4,3)*momenta(5,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(3,3)*momenta(4,3)*momenta(5,3)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(3,4)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(5,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(5,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)*momenta(5,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,1)*momenta(5,2)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(4,4)
      acc = momenta(2,1)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,1)
      reg2 = acc * momenta(4,3)
      acc = momenta(2,3)*momenta(4,1)*momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)*momenta(5,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,3)*momenta(3,3)*momenta(4,3)*momenta(5,3)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(5,4)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg2 = acc * momenta(4,3)
      acc = momenta(2,3)*momenta(4,2)*momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(4,3)*momenta(5,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)*momenta(4,3)*momenta(5,3)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(6,4)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(3,1)
      acc = momenta(3,0)*momenta(5,2)
      acc = acc + momenta(3,2)*momenta(5,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(2,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(5,2)
      acc = momenta(3,0)*momenta(5,1)
      acc = acc + momenta(3,1)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg5 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg5
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc * momenta(4,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(1,5)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg3 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,1)
      acc = acc + momenta(1,1)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg3 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,3)
      acc = acc + reg4
      reg3 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg4 = acc * momenta(3,1)
      acc = momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg4
      reg3 = acc * momenta(1,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg5 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg5
      acc = acc * momenta(1,1)
      acc = acc + reg3
      acc = acc * momenta(5,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(2,5)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg2 = acc * momenta(5,0)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg3 = acc * momenta(3,0)
      acc = momenta(3,2)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,2)
      acc = acc * momenta(2,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(5,2)
      acc = acc + momenta(1,2)*momenta(5,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg4
      reg3 = acc * momenta(5,2)
      acc = momenta(3,0)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg4 = acc * momenta(3,2)
      acc = momenta(2,2)*momenta(3,3)*momenta(5,2)
      acc = acc + reg4
      reg3 = acc * momenta(1,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg5 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(5,3)
      acc = acc + reg5
      acc = acc * momenta(1,2)
      acc = acc + reg3
      acc = acc * momenta(4,0)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(3,5)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg2 = acc * momenta(5,1)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg3 = acc * momenta(5,3)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(5,2)
      acc = acc + momenta(1,2)*momenta(5,1)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc * momenta(5,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg3 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(5,2)
      acc = momenta(3,1)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,1)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg4 = acc * momenta(3,2)
      acc = momenta(2,2)*momenta(3,3)*momenta(5,2)
      acc = acc + reg4
      reg3 = acc * momenta(1,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg5 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(5,3)
      acc = acc + reg5
      acc = acc * momenta(1,2)
      acc = acc + reg3
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(4,5)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)*momenta(4,0)*momenta(5,0)
      res = res + acc * coeffs%c1(1,5)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)*momenta(4,1)*momenta(5,1)
      res = res + acc * coeffs%c1(2,5)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,2)*momenta(5,2)
      res = res + acc * coeffs%c1(3,5)
      acc = momenta(1,3)*momenta(2,3)*momenta(3,3)*momenta(4,3)*momenta(5,3)
      res = res + acc * coeffs%c1(4,5)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg2 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg3
      acc = acc * momenta(3,1)
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg3 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg3
      reg2 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,0)*momenta(4,1)
      acc = acc + reg2
      acc = acc * momenta(5,0)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(1,7)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg2
      reg1 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg3
      acc = acc * momenta(5,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(5,0)
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)*momenta(5,2)
      acc = acc + reg2
      acc = acc * momenta(4,0)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(2,7)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,0)*momenta(4,3)
      acc = acc + reg2
      reg1 = acc * momenta(5,0)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg3 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(3,3)*momenta(4,0)
      acc = acc + reg3
      acc = acc * momenta(5,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(2,0)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(2,3)*momenta(4,0)*momenta(5,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,0)*momenta(4,3)*momenta(5,3)
      acc = acc + reg2
      acc = acc * momenta(1,0)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(3,7)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg2
      reg1 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg3
      acc = acc * momenta(5,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(5,1)
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)*momenta(5,2)
      acc = acc + reg2
      acc = acc * momenta(4,1)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(4,7)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg2
      reg1 = acc * momenta(5,1)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg3 = acc * momenta(3,1)
      acc = momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg3
      acc = acc * momenta(5,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(2,1)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,1)
      reg3 = acc * momenta(4,3)
      acc = momenta(2,3)*momenta(4,1)*momenta(5,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)*momenta(5,3)
      acc = acc + reg2
      acc = acc * momenta(1,1)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(5,7)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(4,2)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg3 = acc * momenta(3,2)
      acc = momenta(2,2)*momenta(3,3)*momenta(5,2)
      acc = acc + reg3
      acc = acc * momenta(4,3)
      acc = acc + reg1
      reg0 = acc * momenta(1,3)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg3 = acc * momenta(4,3)
      acc = momenta(2,3)*momenta(4,2)*momenta(5,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,2)*momenta(4,3)*momenta(5,3)
      acc = acc + reg2
      acc = acc * momenta(1,2)
      acc = acc + reg0
      acc = acc / 10.0_ki
      res = res + acc * coeffs%c2(6,7)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(3,1)*momenta(5,2)
      acc = acc + momenta(3,2)*momenta(5,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(5,2)
      acc = momenta(3,0)*momenta(5,1)
      acc = acc + momenta(3,1)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg4
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg5 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg5
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc * momenta(4,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(1,8)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg3 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,1)
      acc = acc + momenta(1,1)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg3 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg4 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(4,3)
      acc = acc + reg4
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg5 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg5
      acc = acc * momenta(3,3)
      acc = acc + reg3
      acc = acc * momenta(5,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(2,8)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      reg2 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg3 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,0)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg3 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,0)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg4
      reg3 = acc * momenta(4,0)
      acc = momenta(3,2)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,2)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      reg4 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,3)*momenta(4,3)
      acc = acc + reg4
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg5 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg5
      acc = acc * momenta(3,3)
      acc = acc + reg3
      acc = acc * momenta(5,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(3,8)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg2 = acc * momenta(4,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg3 = acc * momenta(3,2)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      reg2 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc * momenta(4,3)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg3 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      acc = acc * momenta(3,3)
      acc = acc + reg4
      reg3 = acc * momenta(2,1)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg4 = acc * momenta(3,1)
      acc = momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg4
      reg3 = acc * momenta(1,3)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg5 = acc * momenta(3,3)
      acc = momenta(2,3)*momenta(3,1)*momenta(4,3)
      acc = acc + reg5
      acc = acc * momenta(1,1)
      acc = acc + reg3
      acc = acc * momenta(5,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(4,8)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,1)*momenta(4,0)
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)*momenta(4,0)*momenta(5,1)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(1,10)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg2 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,2)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)*momenta(4,0)
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)*momenta(4,0)*momenta(5,2)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(2,10)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg2 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,3)*momenta(4,0)
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,0)*momenta(4,0)*momenta(5,3)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(3,10)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg2 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,2)*momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)*momenta(4,1)*momenta(5,2)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(4,10)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg2 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,3)*momenta(4,1)
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)*momenta(4,1)
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)*momenta(4,1)*momenta(5,3)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(5,10)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg2 = acc * momenta(5,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(5,3)
      acc = acc + reg2
      reg1 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)*momenta(5,2)
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)*momenta(4,3)*momenta(5,2)
      acc = acc + reg0
      acc = acc / 5.0_ki
      res = res + acc * coeffs%c2(6,10)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg2 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg3 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,2)
      acc = acc + momenta(1,2)*momenta(4,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,2)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg4 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,2)
      acc = acc + momenta(3,2)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg4 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg4
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg5 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg5
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc * momenta(5,2)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(1,9)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(3,3)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,0)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,0)
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg3 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(4,0)
      acc = momenta(3,1)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,1)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,1)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg4 = acc * momenta(2,1)
      acc = momenta(1,1)*momenta(2,0)*momenta(4,1)
      acc = acc + reg4
      reg3 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg5 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(4,1)
      acc = acc + reg5
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc * momenta(5,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(2,9)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      reg3 = acc * momenta(3,2)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(3,0)
      acc = momenta(3,2)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,2)
      acc = acc * momenta(1,0)
      acc = acc * momenta(2,0)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(5,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg4
      reg3 = acc * momenta(5,2)
      acc = momenta(3,0)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,0)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg4
      reg3 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,0)
      reg5 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg5
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(3,9)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg2 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg3 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc * momenta(5,2)
      acc = acc + reg3
      reg2 = acc * momenta(3,1)
      acc = momenta(3,2)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,2)
      acc = acc * momenta(1,1)
      acc = acc * momenta(2,1)
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(4,2)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg3 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(5,3)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc * momenta(5,2)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(5,2)
      acc = momenta(3,1)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,1)
      acc = acc * momenta(1,2)
      acc = acc * momenta(2,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg4
      reg3 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg5 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg5
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc * momenta(4,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 30.0_ki
      res = res + acc * coeffs%c3(4,9)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg2 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg3 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(4,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg3 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(3,2)
      acc = momenta(1,1)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,1)
      reg4 = acc * momenta(3,0)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg5 = acc * momenta(3,3)
      acc = momenta(1,0)*momenta(4,3)
      acc = acc + momenta(1,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(2,2)
      acc = momenta(2,1)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,1)
      reg5 = acc * momenta(3,0)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg6 = acc * momenta(3,3)
      acc = momenta(2,0)*momenta(4,3)
      acc = acc + momenta(2,3)*momenta(4,0)
      acc = acc * momenta(3,1)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,2)
      acc = acc + reg3
      acc = acc + reg2
      acc = acc + reg1
      reg0 = acc * momenta(5,1)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg3 = acc * momenta(4,2)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg4 = acc * momenta(4,3)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc * momenta(4,1)
      acc = acc + reg4
      acc = acc + reg3
      reg2 = acc * momenta(5,0)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg4 = acc * momenta(4,2)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      reg5 = acc * momenta(2,2)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      acc = acc * momenta(1,2)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(5,3)
      acc = momenta(2,0)*momenta(4,1)
      acc = acc + momenta(2,1)*momenta(4,0)
      reg5 = acc * momenta(1,3)
      acc = momenta(1,0)*momenta(2,1)
      acc = acc + momenta(1,1)*momenta(2,0)
      reg6 = acc * momenta(4,3)
      acc = momenta(1,0)*momenta(4,1)
      acc = acc + momenta(1,1)*momenta(4,0)
      acc = acc * momenta(2,3)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(5,2)
      acc = acc + reg3
      acc = acc + reg2
      reg1 = acc * momenta(3,1)
      acc = momenta(1,2)*momenta(3,3)
      acc = acc + momenta(1,3)*momenta(3,2)
      reg4 = acc * momenta(5,0)
      acc = momenta(1,2)*momenta(5,3)
      acc = acc + momenta(1,3)*momenta(5,2)
      reg5 = acc * momenta(3,0)
      acc = momenta(3,2)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,2)
      acc = acc * momenta(1,0)
      acc = acc + reg5
      acc = acc + reg4
      reg3 = acc * momenta(4,1)
      acc = momenta(3,0)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,0)
      reg5 = acc * momenta(4,2)
      acc = momenta(4,0)*momenta(5,3)
      acc = acc + momenta(4,3)*momenta(5,0)
      reg6 = acc * momenta(3,2)
      acc = momenta(3,0)*momenta(4,3)
      acc = acc + momenta(3,3)*momenta(4,0)
      acc = acc * momenta(5,2)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,1)
      acc = acc + reg3
      reg2 = acc * momenta(2,1)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg5 = acc * momenta(5,0)
      acc = momenta(2,2)*momenta(5,3)
      acc = acc + momenta(2,3)*momenta(5,2)
      reg6 = acc * momenta(3,0)
      acc = momenta(3,2)*momenta(5,3)
      acc = acc + momenta(3,3)*momenta(5,2)
      acc = acc * momenta(2,0)
      acc = acc + reg6
      acc = acc + reg5
      acc = acc * momenta(1,1)
      acc = acc * momenta(4,1)
      acc = acc + reg2
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 60.0_ki
      res = res + acc * coeffs%c4(1,4)
   case default
      res = 0.0_ki
   end select
end  function contract_a_tensor_5
pure function contract_b_tensor_5(coeffs, momenta) result(res)
   ! generated by: write_function_b_tensor_contract
   implicit none
   type(coeff_type_5), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   real(ki) :: reg0
   real(ki) :: reg1
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(0)
      res = coeffs%c1(1,2)
      res = res - coeffs%c1(2,2)
      res = res - coeffs%c1(3,2)
      res = res - coeffs%c1(4,2)
   case(1)
      acc = -momenta(1,0)
      res = acc * coeffs%c2(1,2)
      acc = -momenta(1,0)
      res = res + acc * coeffs%c2(2,2)
      acc = -momenta(1,0)
      res = res + acc * coeffs%c2(3,2)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c2(4,2)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c2(5,2)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c2(6,2)
      acc = 3*momenta(1,0)
      res = res + acc * coeffs%c1(1,3)
      acc = -3*momenta(1,1)
      res = res + acc * coeffs%c1(2,3)
      acc = -3*momenta(1,2)
      res = res + acc * coeffs%c1(3,3)
      acc = -3*momenta(1,3)
      res = res + acc * coeffs%c1(4,3)
      acc = momenta(1,1)
      res = res + acc * coeffs%c2(1,5)
      acc = momenta(1,2)
      res = res + acc * coeffs%c2(2,5)
      acc = momenta(1,3)
      res = res + acc * coeffs%c2(3,5)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c2(4,5)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c2(5,5)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c2(6,5)
   case(2)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = acc * coeffs%c3(1,4)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(2,4)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(3,4)
      acc = -momenta(1,1)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(4,4)
      acc = -3*momenta(1,0)*momenta(2,1)
      acc = acc - 3*momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,3)
      acc = -3*momenta(1,0)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,3)
      acc = -3*momenta(1,0)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,3)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,3)
      acc = -3*momenta(1,1)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,3)
      acc = -3*momenta(1,2)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(1,7)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(2,7)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(3,7)
      acc = -momenta(1,2)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(4,7)
      acc = 3*momenta(1,0)*momenta(2,1)
      acc = acc + 3*momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(1,8)
      acc = 3*momenta(1,0)*momenta(2,2)
      acc = acc + 3*momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(2,8)
      acc = 3*momenta(1,0)*momenta(2,3)
      acc = acc + 3*momenta(1,3)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(3,8)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(4,8)
      acc = -3*momenta(1,1)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(5,8)
      acc = -3*momenta(1,2)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,2)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c2(6,8)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(1,2)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(2,2)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(3,2)
      acc = -momenta(1,1)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,1)
      acc = acc / 2.0_ki
      res = res + acc * coeffs%c3(4,2)
      acc = momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c2(1,6)
      acc = momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c2(2,6)
      acc = momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c2(3,6)
      acc = -momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c2(4,6)
      acc = -momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c2(5,6)
      acc = -momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c2(6,6)
      acc = -momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c2(1,6)
      acc = -momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c2(2,6)
      acc = -momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c2(3,6)
      acc = -momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c2(4,6)
      acc = -momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c2(5,6)
      acc = -momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c2(6,6)
      acc = 6*momenta(1,0)*momenta(2,0)
      res = res + acc * coeffs%c1(1,4)
      acc = -6*momenta(1,1)*momenta(2,1)
      res = res + acc * coeffs%c1(2,4)
      acc = -6*momenta(1,2)*momenta(2,2)
      res = res + acc * coeffs%c1(3,4)
      acc = -6*momenta(1,3)*momenta(2,3)
      res = res + acc * coeffs%c1(4,4)
   case(3)
      acc = 3*momenta(1,0)*momenta(2,1)
      acc = acc + 3*momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,1)
      acc = 3*momenta(1,1)*momenta(2,1)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = acc * coeffs%c2(1,9)
      acc = 3*momenta(1,0)*momenta(2,2)
      acc = acc + 3*momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,2)
      acc = 3*momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,9)
      acc = 3*momenta(2,0)*momenta(3,3)
      acc = acc + 3*momenta(2,3)*momenta(3,0)
      reg0 = acc * momenta(1,3)
      acc = 3*momenta(1,0)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,9)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,2)
      acc = -3*momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,9)
      acc = -3*momenta(2,1)*momenta(3,3)
      acc = acc - 3*momenta(2,3)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = -3*momenta(1,1)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,9)
      acc = -3*momenta(2,2)*momenta(3,3)
      acc = acc - 3*momenta(2,3)*momenta(3,2)
      reg0 = acc * momenta(1,3)
      acc = -3*momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,9)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,0)
      res = res + acc * coeffs%c2(1,9)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,0)
      res = res + acc * coeffs%c2(2,9)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,0)
      res = res + acc * coeffs%c2(3,9)
      acc = -momenta(1,1)*momenta(2,1)*momenta(3,1)
      res = res + acc * coeffs%c2(4,9)
      acc = -momenta(1,1)*momenta(2,1)*momenta(3,1)
      res = res + acc * coeffs%c2(5,9)
      acc = -momenta(1,2)*momenta(2,2)*momenta(3,2)
      res = res + acc * coeffs%c2(6,9)
      acc = 3*momenta(1,1)*momenta(2,2)
      acc = acc + 3*momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = 3*momenta(1,0)*momenta(2,1)
      acc = acc + 3*momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = 3*momenta(1,0)*momenta(2,2)
      acc = acc + 3*momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(1,10)
      acc = 3*momenta(1,1)*momenta(2,3)
      acc = acc + 3*momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = 3*momenta(1,0)*momenta(2,1)
      acc = acc + 3*momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,3)
      acc = 3*momenta(1,0)*momenta(2,3)
      acc = acc + 3*momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(2,10)
      acc = 3*momenta(1,2)*momenta(2,3)
      acc = acc + 3*momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,0)
      acc = 3*momenta(1,0)*momenta(2,3)
      acc = acc + 3*momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = 3*momenta(1,0)*momenta(2,2)
      acc = acc + 3*momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(3,10)
      acc = -3*momenta(2,1)*momenta(3,2)
      acc = acc - 3*momenta(2,2)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,3)
      acc = -3*momenta(1,1)*momenta(3,2)
      acc = acc - 3*momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(4,10)
      acc = -momenta(1,1)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c4(1,2)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,1)
      acc = acc - 3*momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = -3*momenta(1,0)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(1,3)
      acc = -3*momenta(1,1)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,1)
      acc = acc - 3*momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,3)
      acc = -3*momenta(1,0)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(2,3)
      acc = -3*momenta(1,2)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = -3*momenta(1,0)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(3,3)
      acc = -3*momenta(2,1)*momenta(3,2)
      acc = acc - 3*momenta(2,2)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,3)
      acc = -3*momenta(1,1)*momenta(3,2)
      acc = acc - 3*momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(4,3)
      acc = momenta(2,1)*momenta(3,2)
      acc = acc + momenta(2,2)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,3)
      acc = momenta(1,1)*momenta(3,2)
      acc = acc + momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c4(1,5)
      acc = -momenta(1,1)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,3)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c4(1,3)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,1)
      acc = acc - 3*momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = -3*momenta(1,0)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(1,6)
      acc = -3*momenta(1,1)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,1)
      acc = acc - 3*momenta(1,1)*momenta(2,0)
      reg1 = acc * momenta(3,3)
      acc = -3*momenta(1,0)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,0)
      acc = acc * momenta(3,1)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(2,6)
      acc = -3*momenta(1,2)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = -3*momenta(1,0)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(3,6)
      acc = -3*momenta(2,1)*momenta(3,2)
      acc = acc - 3*momenta(2,2)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      reg1 = acc * momenta(3,3)
      acc = -3*momenta(1,1)*momenta(3,2)
      acc = acc - 3*momenta(1,2)*momenta(3,1)
      acc = acc * momenta(2,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c3(4,6)
      acc = -6*momenta(1,0)*momenta(2,1)
      acc = acc - 6*momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,1)
      acc = -6*momenta(1,1)*momenta(2,1)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(1,4)
      acc = -6*momenta(1,0)*momenta(2,2)
      acc = acc - 6*momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,2)
      acc = -6*momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,4)
      acc = -6*momenta(2,0)*momenta(3,3)
      acc = acc - 6*momenta(2,3)*momenta(3,0)
      reg0 = acc * momenta(1,3)
      acc = -6*momenta(1,0)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,4)
      acc = -6*momenta(1,1)*momenta(2,2)
      acc = acc - 6*momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,2)
      acc = -6*momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,4)
      acc = -6*momenta(2,1)*momenta(3,3)
      acc = acc - 6*momenta(2,3)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = -6*momenta(1,1)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,4)
      acc = -6*momenta(2,2)*momenta(3,3)
      acc = acc - 6*momenta(2,3)*momenta(3,2)
      reg0 = acc * momenta(1,3)
      acc = -6*momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,4)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,2)
      acc = -momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(1,5)
      acc = -momenta(2,0)*momenta(3,3)
      acc = acc - momenta(2,3)*momenta(3,0)
      reg0 = acc * momenta(1,3)
      acc = -momenta(1,0)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(2,5)
      acc = -momenta(2,0)*momenta(3,3)
      acc = acc - momenta(2,3)*momenta(3,0)
      reg0 = acc * momenta(1,3)
      acc = -momenta(1,0)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(3,5)
      acc = -momenta(2,1)*momenta(3,3)
      acc = acc - momenta(2,3)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = -momenta(1,1)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(4,5)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,1)
      acc = -momenta(1,1)*momenta(2,1)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(1,5)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,1)
      acc = -momenta(1,1)*momenta(2,1)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(2,5)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,2)
      acc = -momenta(1,2)*momenta(2,2)*momenta(3,0)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(3,5)
      acc = -momenta(1,1)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,2)
      acc = -momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(4,5)
      acc = 10*momenta(1,0)*momenta(2,0)*momenta(3,0)
      res = res + acc * coeffs%c1(1,5)
      acc = -10*momenta(1,1)*momenta(2,1)*momenta(3,1)
      res = res + acc * coeffs%c1(2,5)
      acc = -10*momenta(1,2)*momenta(2,2)*momenta(3,2)
      res = res + acc * coeffs%c1(3,5)
      acc = -10*momenta(1,3)*momenta(2,3)*momenta(3,3)
      res = res + acc * coeffs%c1(4,5)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,1)
      res = res + acc * coeffs%c2(1,7)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,2)
      res = res + acc * coeffs%c2(2,7)
      acc = momenta(1,3)*momenta(2,3)*momenta(3,3)
      res = res + acc * coeffs%c2(3,7)
      acc = -momenta(1,2)*momenta(2,2)*momenta(3,2)
      res = res + acc * coeffs%c2(4,7)
      acc = -momenta(1,3)*momenta(2,3)*momenta(3,3)
      res = res + acc * coeffs%c2(5,7)
      acc = -momenta(1,3)*momenta(2,3)*momenta(3,3)
      res = res + acc * coeffs%c2(6,7)
      acc = -3*momenta(1,0)*momenta(2,1)
      acc = acc - 3*momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,0)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(1,7)
      acc = -3*momenta(1,0)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,7)
      acc = -3*momenta(1,0)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -3*momenta(1,0)*momenta(2,0)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,7)
      acc = -3*momenta(1,1)*momenta(2,2)
      acc = acc - 3*momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = -3*momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,7)
      acc = -3*momenta(1,1)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = -3*momenta(1,1)*momenta(2,1)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,7)
      acc = -3*momenta(1,2)*momenta(2,3)
      acc = acc - 3*momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,2)
      acc = -3*momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,7)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(1,8)
      acc = momenta(2,1)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,1)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,1)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(2,8)
      acc = momenta(2,2)*momenta(3,3)
      acc = acc + momenta(2,3)*momenta(3,2)
      reg0 = acc * momenta(1,3)
      acc = momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(3,8)
      acc = -momenta(2,2)*momenta(3,3)
      acc = acc - momenta(2,3)*momenta(3,2)
      reg0 = acc * momenta(1,3)
      acc = -momenta(1,2)*momenta(2,3)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(4,8)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(1,8)
      acc = -momenta(1,0)*momenta(2,1)
      acc = acc - momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(2,8)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(3,8)
      acc = -momenta(1,1)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = -momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(4,8)
      acc = 6*momenta(1,0)*momenta(2,1)
      acc = acc + 6*momenta(1,1)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = 6*momenta(1,0)*momenta(2,0)*momenta(3,1)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(1,10)
      acc = 6*momenta(1,0)*momenta(2,2)
      acc = acc + 6*momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = 6*momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(2,10)
      acc = 6*momenta(1,0)*momenta(2,3)
      acc = acc + 6*momenta(1,3)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = 6*momenta(1,0)*momenta(2,0)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(3,10)
      acc = -6*momenta(1,1)*momenta(2,2)
      acc = acc - 6*momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = -6*momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(4,10)
      acc = -6*momenta(1,1)*momenta(2,3)
      acc = acc - 6*momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = -6*momenta(1,1)*momenta(2,1)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(5,10)
      acc = -6*momenta(1,2)*momenta(2,3)
      acc = acc - 6*momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,2)
      acc = -6*momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c2(6,10)
      acc = momenta(1,1)*momenta(2,2)
      acc = acc + momenta(1,2)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(1,9)
      acc = momenta(1,1)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = momenta(1,1)*momenta(2,1)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(2,9)
      acc = momenta(1,2)*momenta(2,3)
      acc = acc + momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,2)
      acc = momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(3,9)
      acc = -momenta(1,2)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,2)
      acc = -momenta(1,2)*momenta(2,2)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(4,9)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,2)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(1,9)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(2,9)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,0)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(3,9)
      acc = -momenta(1,1)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,1)
      reg0 = acc * momenta(3,1)
      acc = -momenta(1,1)*momenta(2,1)*momenta(3,3)
      acc = acc + reg0
      acc = acc / 3.0_ki
      res = res + acc * coeffs%c3(4,9)
      acc = -momenta(1,2)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,2)
      reg0 = acc * momenta(3,0)
      acc = -momenta(1,0)*momenta(2,3)
      acc = acc - momenta(1,3)*momenta(2,0)
      reg1 = acc * momenta(3,2)
      acc = -momenta(1,0)*momenta(2,2)
      acc = acc - momenta(1,2)*momenta(2,0)
      acc = acc * momenta(3,3)
      acc = acc + reg1
      acc = acc + reg0
      acc = acc / 6.0_ki
      res = res + acc * coeffs%c4(1,4)
   case default
      res = 0.0_ki
   end select
end  function contract_b_tensor_5
pure function contract_c_tensor_5(coeffs, momenta) result(res)
   ! generated by: write_function_c_tensor_contract
   implicit none
   type(coeff_type_5), intent(in) :: coeffs
   real(ki), dimension(:,0:), intent(in), optional :: momenta
   complex(ki) :: res
   integer :: rk
   real(ki) :: acc
   if (present(momenta)) then
      rk = size(momenta, 1)
   else
      rk = 0
   end if
   select case(rk)
   case(0)
      res = -coeffs%c2(1,6)
      res = res - coeffs%c2(2,6)
      res = res - coeffs%c2(3,6)
      res = res + coeffs%c2(4,6)
      res = res + coeffs%c2(5,6)
      res = res + coeffs%c2(6,6)
      acc = 3
      res = res + acc * coeffs%c1(1,4)
      acc = 3
      res = res + acc * coeffs%c1(2,4)
      acc = 3
      res = res + acc * coeffs%c1(3,4)
      acc = 3
      res = res + acc * coeffs%c1(4,4)
   case(1)
      acc = -3*momenta(1,0)
      res = acc * coeffs%c2(1,9)
      acc = -3*momenta(1,0)
      res = res + acc * coeffs%c2(2,9)
      acc = -3*momenta(1,0)
      res = res + acc * coeffs%c2(3,9)
      acc = 3*momenta(1,1)
      res = res + acc * coeffs%c2(4,9)
      acc = 3*momenta(1,1)
      res = res + acc * coeffs%c2(5,9)
      acc = 3*momenta(1,2)
      res = res + acc * coeffs%c2(6,9)
      acc = 3*momenta(1,0)
      res = res + acc * coeffs%c2(1,4)
      acc = 3*momenta(1,0)
      res = res + acc * coeffs%c2(2,4)
      acc = 3*momenta(1,0)
      res = res + acc * coeffs%c2(3,4)
      acc = 3*momenta(1,1)
      res = res + acc * coeffs%c2(4,4)
      acc = 3*momenta(1,1)
      res = res + acc * coeffs%c2(5,4)
      acc = 3*momenta(1,2)
      res = res + acc * coeffs%c2(6,4)
      acc = momenta(1,0)
      res = res + acc * coeffs%c3(1,5)
      acc = momenta(1,0)
      res = res + acc * coeffs%c3(2,5)
      acc = momenta(1,0)
      res = res + acc * coeffs%c3(3,5)
      acc = momenta(1,1)
      res = res + acc * coeffs%c3(4,5)
      acc = 15*momenta(1,0)
      res = res + acc * coeffs%c1(1,5)
      acc = 15*momenta(1,1)
      res = res + acc * coeffs%c1(2,5)
      acc = 15*momenta(1,2)
      res = res + acc * coeffs%c1(3,5)
      acc = 15*momenta(1,3)
      res = res + acc * coeffs%c1(4,5)
      acc = -3*momenta(1,1)
      res = res + acc * coeffs%c2(1,7)
      acc = -3*momenta(1,2)
      res = res + acc * coeffs%c2(2,7)
      acc = -3*momenta(1,3)
      res = res + acc * coeffs%c2(3,7)
      acc = 3*momenta(1,2)
      res = res + acc * coeffs%c2(4,7)
      acc = 3*momenta(1,3)
      res = res + acc * coeffs%c2(5,7)
      acc = 3*momenta(1,3)
      res = res + acc * coeffs%c2(6,7)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c3(1,8)
      acc = -momenta(1,1)
      res = res + acc * coeffs%c3(2,8)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c3(3,8)
      acc = momenta(1,2)
      res = res + acc * coeffs%c3(4,8)
      acc = 3*momenta(1,1)
      res = res + acc * coeffs%c2(1,10)
      acc = 3*momenta(1,2)
      res = res + acc * coeffs%c2(2,10)
      acc = 3*momenta(1,3)
      res = res + acc * coeffs%c2(3,10)
      acc = 3*momenta(1,2)
      res = res + acc * coeffs%c2(4,10)
      acc = 3*momenta(1,3)
      res = res + acc * coeffs%c2(5,10)
      acc = 3*momenta(1,3)
      res = res + acc * coeffs%c2(6,10)
      acc = -momenta(1,2)
      res = res + acc * coeffs%c3(1,9)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c3(2,9)
      acc = -momenta(1,3)
      res = res + acc * coeffs%c3(3,9)
      acc = momenta(1,3)
      res = res + acc * coeffs%c3(4,9)
   case default
      res = 0.0_ki
   end select
end  function contract_c_tensor_5
end module [% process_name asprefix=\_ %]pjfry_comb
